=begin

(c) CadFather 2013
(c) RENDERIZA 2013

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE.

== Information
Authors:: 
	*CadFather
	*Renderiza

Name:: [RE]SCENE
Version:: 1.0.7
SU Version:: v8
Date:: 6/30/2013
Description:: Applies current page style to others pages that are included in animation with just one click. 
Usage:: Set up your current scene with your favourite style, shadows, guides visibility etc. > go to Plugins > .::Renderiza::. > [RE]SCENE. all other scenes will be updated to match the current one.
History::
1.0.0:: 5/2/2013
	* Original release.  
1.0.1:: 5/4/2013	
	* Previous Page
	* Next Page
	* Delete Page
	* Add Scene 
1.0.2:: 5/8/2013	
	* All Scenes
	* Single Scenes
	* Drawing Style 
	* Camera Location 
	* Shadow Settings 
	* Axes Location 
	* Hidden Geometry 
	* Visible Layers
	* Active Section Planes 
1.0.3:: 5/22/2013
	* Made into Extension
1.0.4:: 5/24/2013
	* Made compatible with Extension Warehouse
1.0.5:: 5/30/2013
	* [Re]name Scenes 
	* [Re]order Scenes 
1.0.6:: 5/30/2013
	* Fixed freeze problem
1.0.7:: 6/30/2013
	* Changed Sketchup.send_action() : Arguments to be Mac compatible
=end

module RND_Extensions

	module RND_Rescene
		require 'sketchup.rb'
		require 'extensions.rb'

		unless file_loaded?( __FILE__ )
			file_loaded( __FILE__ )
			# Create the extension.
			ext = SketchupExtension.new '[Re]Scene', 'RND_Rescene/RND_Rescene_menus.rb'

			# Attach some nice info.
			ext.creator     = '| Renderiza | CadFather |'
			ext.version     = '1.0.7'
			ext.copyright   = '2013, Renderiza Studio.'
			ext.description = 'Applies current page style to others pages that are included in animation.'

			# Register and load the extension on startup.
			Sketchup.register_extension ext, true
		end

	end

end

file_loaded( __FILE__ )