=begin

(c) CadFather 2013
(c) RENDERIZA 2013

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE.

== Information
Authors:: 
	*CadFather
	*Renderiza

Name:: [RE]SCENE
Version:: 1.0.7
SU Version:: v8
Date:: 6/30/2013
Description:: Applies current page style to others pages that are included in animation with just one click. 
Usage:: Set up your current scene with your favourite style, shadows, guides visibility etc. > go to Plugins > .::Renderiza::. > [RE]SCENE. all other scenes will be updated to match the current one.
History::
1.0.0:: 5/2/2013
	* Original release.  
1.0.1:: 5/4/2013	
	* Previous Page
	* Next Page
	* Delete Page
	* Add Scene 
1.0.2:: 5/8/2013	
	* All Scenes
	* Single Scenes
	* Drawing Style 
	* Camera Location 
	* Shadow Settings 
	* Axes Location 
	* Hidden Geometry 
	* Visible Layers
	* Active Section Planes 
1.0.3:: 5/22/2013
	* Made into Extension
1.0.4:: 5/24/2013
	* Made compatible with Extension Warehouse
1.0.5:: 5/30/2013
	* [Re]name Scenes 
	* [Re]order Scenes 
1.0.6:: 5/30/2013
	* Fixed freeze problem
1.0.7:: 6/30/2013
	* Changed Sketchup.send_action() : Arguments to be Mac compatible
=end

module RND_Extensions

	module RND_RESCENE
		require 'sketchup.rb'
		require 'RND_Rescene/RND_Rescene_loader.rb'
	end

	if !file_loaded?('rnd_menu_loader')
		@@rnd_tools_menu = UI.menu("Plugins").add_submenu("Renderiza Tools") 
	end 

	#------New menu Items---------------------------
	if !file_loaded?('rnd_ew_loader')
		@@rnd_ew_menu = @@rnd_tools_menu.add_submenu("Websites") 
		@@rnd_ew_menu.add_separator 
		@@rnd_ew_menu.add_item("Google Sites"){UI.openURL('https://sites.google.com/site/renderizastudio/')}
		@@rnd_ew_menu.add_item("Blogger"){UI.openURL('http://renderizastudio.blogspot.com/')}
		@@rnd_ew_menu.add_item("YouTube"){UI.openURL('http://www.youtube.com/renderizastudio')} 
		@@rnd_ew_menu.add_item("Twitter"){UI.openURL('https://twitter.com/RenderizaStudio')}
		@@rnd_ew_menu.add_item("Google+"){UI.openURL('https://plus.google.com/u/0/100658341914902555650/posts')}
		@@rnd_tools_menu.add_separator
		@@rnd_ew_menu.add_separator
	end 
	#------------------------------------------------

	if !file_loaded?(__FILE__) #then
		@@rnd_tools_menu.add_item('[Re]Scene') {
			Sketchup.active_model.select_tool RND_Extensions::RND_Rescene::Rescene.new
		}
		# Add toolbars
		rnd_rescene_tb = UI::Toolbar.new "[Re]Scene"
		rnd_rescene_cmd = UI::Command.new("[Re]Scene") {
			Sketchup.active_model.select_tool RND_Extensions::RND_Rescene::Rescene.new
		}
		rnd_rescene_redo_cmd = UI::Command.new("[Redo]Scene") {
			model = Sketchup.active_model
			pages = model.pages
			layers = model.layers
			c_page = pages.selected_page

			pages.each {|page|
				if page.label[-1..-1] != ")"
					###########
					page.update(2)
					###########
				end
			}
		}

		# icons toolbar
		rnd_rescene_cmd.small_icon = "img/cad_rescene_1_16.png"
		rnd_rescene_cmd.large_icon = "img/cad_rescene_1_24.png"
		rnd_rescene_cmd.tooltip = "[Re]Scene"
		rnd_rescene_cmd.status_bar_text = "Set current page style to others pages."
		rnd_rescene_cmd.menu_text = "[Re]Scene"
		rnd_rescene_tb = rnd_rescene_tb.add_item rnd_rescene_cmd
		rnd_rescene_tb.show

		# icons toolbar redo
		rnd_rescene_redo_cmd.small_icon = "img/cad_rescene_2_16.png"
		rnd_rescene_redo_cmd.large_icon = "img/cad_rescene_2_24.png"
		rnd_rescene_redo_cmd.tooltip = "[Redo]Scene"
		rnd_rescene_redo_cmd.status_bar_text = "Set current page style to others pages without web-dialog."
		rnd_rescene_redo_cmd.menu_text = "[Redo]Scene"
		rnd_rescene_tb = rnd_rescene_tb.add_item rnd_rescene_redo_cmd
		rnd_rescene_tb.show

		# Add Context Menu
		UI.add_context_menu_handler{|menu|
			rclick_menu  = menu.add_submenu("[Re]Scene")
			rclick_menu.add_item('Open'){
				Sketchup.active_model.select_tool RND_Extensions::RND_Rescene::Rescene.new
				Sketchup.send_action('selectSelectionTool:')
			}

			rclick_menu.add_item('Update'){
				model = Sketchup.active_model
				pages = model.pages
				layers = model.layers
				c_page = pages.selected_page

				pages.each {|page|
					if page.label[-1..-1] != ")"
						###########
						page.update(2)
						###########					
					end
				}
			}

			rclick_menu.add_separator

			rclick_menu.add_item('Previous Scene'){
				Sketchup.send_action('pagePrevious:')
			}

			rclick_menu.add_item('Next Scene'){
				Sketchup.send_action('pageNext:')
			}

			rclick_menu.add_item('Delete Scene'){
				Sketchup.send_action('pageDelete:')
			}

			rclick_menu.add_item('Add Scene'){
				Sketchup.send_action('pageAdd:')
			}
		}

	end
	
	file_loaded('rnd_ew_loader')
	file_loaded('rnd_menu_loader')
	file_loaded(__FILE__)
end